//+------------------------------------------------------------------+
//|                                               VolExExpert_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"


//#include <stdlib.mqh>
//#include <Tracert.mqh>

//---- input parameters
extern string     Expert_Name = "---- VolExExpert_v1 ----";

extern int        Magic            = 10000;
extern int        Slippage         = 6;

//extern bool       Trace = false;            // Trace Switch

extern string     Main_Parameters = " Trade Volume & Trade Method";
extern double     Lots             = 0.1;    // Lot size
extern bool       StopTrade        = false;  // Stop of Trade switch

extern string     Data = " Input Data ";

extern int        TimeZone         =       0; // Difference between server time and local time   
extern string     TimeStart        = "12:00"; // Start time for openning of orders 
extern string     TimeFinish       = "16:30"; // Finish time time for opening of orders
extern string     TimeBreak        = "14:00"; // Break Time
extern string     StopTradeTime    = "21:30"; // Time of closing orders
extern int        MaxCountLong     =      10; // Max Bars in Profit for Long Exit
extern int        MaxCountShort    =      10; // Max Bars in Profit for Short Exit
extern double     VolFactorLong    =       2; // Volatility Factor for Long
extern double     VolFactorShort   =       2; // Volatility Factor for Short
extern double     DeltaLong        =       0; // Momentum Filter for Long in pips
extern double     DeltaShort       =       0; // Momentum Filter for Short in pips
extern double     StopLoss         =     200; // Max allowable Loss in pips
extern double     StopTarget       =     100; // Target by Loss for Stop of half position 
extern double     StopFactor       =       0; // Decrease of StopLoss
extern double     ProfitTarget     =     100; // Target by Profit for Stop of half position
extern double     GainPlusLong     =       0; // Gain after closing half position for Long (Break-Even) 
extern double     GainPlusShort    =       0; // Gain after closing half position for Short(Break-Even) 

extern string     MM_Parameters = " MoneyManagement by L.Williams ";
extern bool       MM               =   false; //  Switch
extern double     MMRisk           =    0.15; // Risk Factor
extern double     LossMax          =    1000; // Maximum Loss by 1 Lot


int      cnt=0, ticket, mode=0, digit=0, numords, CountLong, CountShort, trade, contr =0;
double   SellProfit=0,BuyProfit=0;
double   BuyStop=0, SellStop=0, SL = 0, Lotsi=0;
bool     BuyInTrade=false, SellInTrade=false;
datetime FinTime=0;
string   com;
int      TotalPips = 0;
double   TotalProfits = 0.0, pastpips[];

double     TakeProfit       =       0; // Take Profit in pips       	
double     InitialStop      =       0; // Initial Stop in pips 
double     BreakEven        =       0; // Breakeven in pips  

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 

//----
   return(0);
  }
  
// ---- Money Management
double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
{
   Lotsi=Lots;
	    
   if ( flag ) Lotsi=NormalizeDouble(Lots*Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
   return(Lotsi);
}   

// ---- Open Sell Orders
void SellOrdOpen()
{		     

		  double SellPrice=Close[1] - iATR(NULL,0,4,1)*VolFactorShort - DeltaShort*Point;
		  
		  if (StopLoss   > 0) SellStop=SellPrice + SL*Point; else SellStop=0;
        if (TakeProfit > 0)    SellProfit=SellPrice - TakeProfit*Point; else SellProfit=0;
	     //Print(" SellPrice=", SellPrice);  
		  ticket = OrderSend( Symbol(),OP_SELLSTOP,Lotsi,
		                      NormalizeDouble(SellPrice, digit),
		                      Slippage,
		                      NormalizeDouble(SellStop , digit),
		                      NormalizeDouble(SellProfit   , digit),
		                      com,Magic,0,Red);
            
        SellInTrade=false;            
            
            if(ticket<0)
            {
            Print("SELLSTOP: OrderSend failed with error #",GetLastError());
            //
            }
        if (GetLastError() == 130) int ticket2=OrderSend(Symbol(),OP_SELL,Lotsi,
                                                         Bid,
                                                         Slippage,
                                                         NormalizeDouble(SellStop , digit),
		                                                   NormalizeDouble(SellProfit   , digit),
		                                                   com,Magic,0,Red);    
      CountShort=0; TotalPips=0;
   return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     

		  double BuyPrice =Close[1] + iATR(NULL,0,4,1)*VolFactorLong + DeltaLong*Point;
		  //Print(" BuyPrice=", BuyPrice); 
		  if (StopLoss > 0) BuyStop = BuyPrice - SL*Point; else BuyStop=0;
        if (TakeProfit>0) BuyProfit=BuyPrice + TakeProfit*Point; else BuyProfit=0;  
		 
		  ticket = OrderSend(Symbol(),OP_BUYSTOP, Lotsi,
		                     NormalizeDouble(BuyPrice, digit),
		                     Slippage,
		                     NormalizeDouble(BuyStop , digit), 
		                     NormalizeDouble(BuyProfit  , digit),
		                     com,Magic,0,Blue);
                
        BuyInTrade=false;            
            
            if(ticket<0)
            {
            Print("BUYSTOP: OrderSend failed with error #",GetLastError());
            //return(0);
            }
      if (GetLastError() == 130) int ticket2=OrderSend(Symbol(),OP_BUY,Lotsi,
                                                       Ask,
                                                       Slippage,
                                                       NormalizeDouble(BuyStop , digit), 
		                                                 NormalizeDouble(BuyProfit  , digit),
		                                                 com,Magic,0,Blue);
      CountLong=0; TotalPips=0;
   return(0);
}      
// ---- Delete Extra Orders
void ExtraOrdDel()
{
    int total = OrdersTotal();
    for (cnt=0;cnt<total;cnt++)
    { 
      OrderSelect(cnt, SELECT_BY_POS);   
      mode=OrderType();
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)     
        {
            if (mode==OP_BUY  && !BuyInTrade) BuyInTrade =true; 
            //&& (OrderMagicNumber()==MagicNumber+1 
            //|| OrderMagicNumber()==MagicNumber+2)) BuyInTrade =true;
            
            if (mode==OP_SELL && !SellInTrade) SellInTrade=true;
           //  && (OrderMagicNumber()==MagicNumber+3 
           // || OrderMagicNumber()==MagicNumber+4)) SellInTrade=true;
            
            if (mode > OP_SELL && (BuyInTrade || SellInTrade)) 
            {
            OrderDelete(OrderTicket());
            }
                        
	     }
	 }        
}
// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   numords = 0;
      
   for(cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()>=OP_BUY && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}

// Closing of Pending Orders      
void PendOrdDel()
{
    int total=OrdersTotal();
    for (int cnt=total-1;cnt>=0;cnt--)
    { 
      OrderSelect(cnt, SELECT_BY_POS,MODE_TRADES);   
      
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)   
           //(OrderMagicNumber()==MagicNumber+1 || OrderMagicNumber()==MagicNumber+2 ||     
           // OrderMagicNumber()==MagicNumber+3 || OrderMagicNumber()==MagicNumber+4))
        {
        int mode=OrderType();
        
        bool result = false;
          switch(mode)
          {
            
            case OP_BUYSTOP   : result = OrderDelete( OrderTicket() ); 
          
            case OP_SELLSTOP  : result = OrderDelete( OrderTicket() ); 
          if(!result)
            {
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
          }
        }
      } 
  return;
  }    
void AllOrdClose(int type)
{
   int total = OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   mode=OrderType();
   bool result = false;
      if ( OrderSymbol()==Symbol() && mode<=OP_SELL && OrderMagicNumber()==Magic)
      //(OrderMagicNumber()==MagicNumber+1 || OrderMagicNumber()==MagicNumber+2 ||     
      // OrderMagicNumber()==MagicNumber+3 || OrderMagicNumber()==MagicNumber+4))
      {
         switch(mode)
         {
         //Close opened long positions
         case OP_BUY       : 
            if (type==0)
            {
            result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, Aqua);
            break;
            }
            else
               if ( type == 1 )
               {
                  if ( OrderComment() == "BUY1")
                  {
                  result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, Aqua);
                  break;
                  }
                  if (contr == 1 && OrderComment() == "BUY3")
                  {
                  result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, Aqua);
                  break;
                  }
               }   
           //Close opened short positions
         case OP_SELL      : 
            if (type==0)
            {
            result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, Magenta);
            break;
            }
            else
               if ( type == 1 )
               {
                  if ( OrderComment() == "SELL1")
                  {
                  result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, Magenta);
                  break;
                  }
                  if (contr == 1 && OrderComment() == "SELL3")
                  {
                  result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, Magenta);
                  break;
                  }
               }                             
            }
         }
      }        
return;
}

void CounterExit()
{
    int total = OrdersTotal();
    for (cnt=0;cnt<total;cnt++)
    { 
      OrderSelect(cnt, SELECT_BY_POS);   
      mode=OrderType();
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)     
        {
            if (mode==OP_BUY)  
            {
            //if (Close[1] > OrderOpenPrice()) CountLong = CountLong+1; 
            if (OrderProfit() > 0) CountLong = CountLong+1;    
               if (CountLong >= MaxCountLong) 
               {
               bool result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, Aqua);
               break;
               }
            }   
            if (mode==OP_SELL)
            {
            //if (Close[1] < OrderOpenPrice()) CountShort = CountShort+1; 
            if (OrderProfit() > 0)  CountShort = CountShort+1;
               if (CountShort >= MaxCountShort) 
               {
               result  = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, Aqua);
               break;
               }
            }   
          
	     }
	 }        
} 

void OpenOrdersProfit()
{
   TotalPips = 0;
	TotalProfits = 0;
	int total = OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
   { 
      OrderSelect(cnt, SELECT_BY_POS);   
      mode=OrderType();
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)     
      {
         switch (mode)
         {
         case OP_BUY:
            TotalPips += MathRound((Bid-OrderOpenPrice())/Point);
            TotalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            TotalPips += MathRound((OrderOpenPrice()-Ask)/Point);
            TotalProfits += OrderProfit();
            break;
         }   
      }   
	}
}

void PastTradeProfit()
{
   int total=HistoryTotal(), n=0;
   ArrayResize(pastpips,total);
   for (int cnt=total-1;cnt>=0;cnt--) 
   {
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)     
      {
         if (!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY) && OrderType() > OP_SELL ) continue;
         
         if (OrderType()==OP_BUY)
         {n = n+1;
         pastpips[n] = MathRound((OrderClosePrice()-OrderOpenPrice())/MarketInfo(Symbol(),MODE_POINT));}
         
         if (OrderType()==OP_SELL)
         {n = n+1;
         pastpips[n] = MathRound((OrderOpenPrice()-OrderClosePrice())/MarketInfo(Symbol(),MODE_POINT));}
      }
   }
}      
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(Bars < 1) {Print("Not enough bars for this strategy");return(0);}
   
   if(AccountFreeMargin()<(1000*Lots)){
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);}
//---- 
//   if ( Trace ) SetTrace();
   
   datetime StartTime = StrToTime(TimeStart) + TimeZone*3600;
   datetime FinTime   = StrToTime(TimeFinish)+ TimeZone*3600;  
   datetime BrkTime   = StrToTime(TimeBreak) + TimeZone*3600; 
   datetime StopTime  = StrToTime(StopTradeTime) + TimeZone*3600; 
    
   digit  = MarketInfo(Symbol(),MODE_DIGITS);
  
   if(!StopTrade && ScanTrades()==0 && (CurTime() >= StartTime && CurTime() <= FinTime && BrkTime != CurTime()))
   {
   Lotsi = MoneyManagement ( MM, Lots, MMRisk, LossMax);
   
   PastTradeProfit();
   
      if ((pastpips[1]+pastpips[2]) < 0 && (pastpips[3]+pastpips[4]) < 0)
      {
      contr = 1;
      SL = (StopLoss - contr*10)/3.0;
      } 
      else
      {
      contr = 0;
      SL = 0.5*StopLoss;
      } 
   
   com = "BUY1"; BuyOrdOpen();
   com = "BUY2"; BuyOrdOpen();
   if (contr == 1) {com = "BUY3"; BuyOrdOpen();}   
   com = "SELL1"; SellOrdOpen();
   com = "SELL2"; SellOrdOpen();
   if (contr == 1) {com = "SELL3"; SellOrdOpen();}
   
   
   trade = 1;
   }
   else
   if (ScanTrades()>0) 
   { 
   ExtraOrdDel();
   CounterExit();   
   OpenOrdersProfit();
   //Print(" TotalPips=",TotalPips);
      if (TotalPips >= ProfitTarget && trade==1) 
      {
      AllOrdClose(1);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType() == OP_BUY ) 
         {
         BuyStop=OrderOpenPrice()+GainPlusLong*Point;
	      OrderModify(OrderTicket(),OrderOpenPrice(),
	                  NormalizeDouble(BuyStop, digit),
	                  OrderTakeProfit(),0,LightBlue);
	      trade=trade+1;
	      //BreakEvenStop(0.5*ProfitTarget,GainPlusLong );
	      }            
   
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType() == OP_SELL) 
         {
         SellStop=OrderOpenPrice()-GainPlusShort*Point;
			OrderModify(OrderTicket(),OrderOpenPrice(),
			            NormalizeDouble(SellStop, digit),
			            OrderTakeProfit(),0,Orange);
         
         trade=trade+1;
         //BreakEvenStop(0.5*ProfitTarget,GainPlusShort );
         }
      }
      
      if (TotalPips <= -StopTarget && trade==1) 
      {
      AllOrdClose(1);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType() == OP_BUY ) 
         {
         BuyStop=OrderOpenPrice()-(SL - StopFactor)*Point;
	      OrderModify(OrderTicket(),OrderOpenPrice(),
	                  NormalizeDouble(BuyStop, digit),
	                  OrderTakeProfit(),0,LightBlue);
	      trade=trade+1;
	      //BreakEvenStop(0.5*ProfitTarget,GainPlusLong );
	      }            
   
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType() == OP_SELL) 
         {
         SellStop=OrderOpenPrice()+(SL - StopFactor)*Point;
			OrderModify(OrderTicket(),OrderOpenPrice(),
			            NormalizeDouble(SellStop, digit),
			            OrderTakeProfit(),0,Orange);
         
         trade=trade+1;
         //BreakEvenStop(0.5*ProfitTarget,GainPlusShort );
         }
      }
   if (CurTime() >= StopTime || StopTrade) {AllOrdClose(0);PendOrdDel();} 
  
   } 
   
 return(0);
}//int start
//+------------------------------------------------------------------+





